{Feedback Servo Demo}

CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        #12, CP0, CP1, CP2, CP3      'servo control pins
        #8,  FP0, FP1, FP2, FP3      'servo feedback pins
        #0, Servo0, Servo1, Servo2, Servo3  'servo names
        sync = 0                     'engineering
VAR
  byte  Cog
  word  commanded, actual     'angles
  long random      
  byte  DisplayServo          'used to display all angles
  word  rcount                'counts random positionings
  
OBJ
  pst      : "parallax serial terminal"
  FBS      : "FourPly"
  
PUB main              
  pst.Start (115_200)                        'start up ser terminal
  pst.str(String("hello, world   "))         'runs in cog 1
  pst.NewLine
  waitcnt(clkfreq/10+cnt)

  cog := FBS.start(0,0, CP1,FP1, CP2, FP2, 0,0)   'specify pin numbers   
  pst.str(string("started position cog: "))       '0,0 pin numbers says no servo
  pst.dec(cog)
  pst.newline  
  dira[sync] := 1                  'scope probe
    
  
  repeat until FBS.getpos(servo2) == 180    'force open loop velocity
     FBS.Width(servo2,1480)
     FBS.width(servo1,1530)
     showangles
     pst.newline     
     waitcnt(clkfreq/100+cnt)
  outa[sync] :=1   
  fbs.width(servo2,1500)          'stop servo
  fbs.width(servo1,1500)
  outa[sync] := 0
  pst.newline
  pst.newline

  
  repeat commanded from 10 to 350 step 5
     MySet(servo1, Commanded)
     MySet(servo2, (360-Commanded))
     waitset(servo1)
     waitset(servo2)
     showangles
     pst.newline
    
  rcount := 0
  repeat while rcount < 500
     if fbs.checkdone(servo1) == 0     'issue command to whichever is done
        pst.str(string("1: "))
        pst.dec(fbs.getpos(servo1))
        ?random
        commanded := || random           'drop sign bit
        commanded := (commanded // 360)    'range 0..359        
        myset(servo1,commanded)
        pst.str(string("  Commanded:  "))
        pst.dec(commanded)
        pst.newline        
        rcount++
        
     if fbs.checkdone(servo2) == 0
        pst.str(string("2: "))
        pst.dec(fbs.getpos(servo2))
        ?random
        commanded := || random           'drop sign bit
        commanded := (commanded // 360)    'range 0..359                    
        myset(servo2,commanded)
        pst.str(string("  Commanded:  "))
        pst.dec(commanded)
        pst.newline
        rcount++   
  pst.str(string("  Done"))   
  repeat                                'stop here        
  
pub MySet(servo, degrees)
     outa[sync] := 1                 'sync
     FBS.SetPos(servo,degrees)   'set position
     outa[sync] := 0

pub WaitSet(servo)            
     repeat while FBS.CheckDone(servo) <> 0    'await completion
     waitcnt(clkfreq/100+cnt)     
     return FBS.getpos(servo)

pub showangles
    repeat displayservo from 0 to 3
      pst.str(string("  Servo"))
      pst.dec(displayservo)
      pst.char(" ")
      pst.dec(FBS.getpos(displayservo))
                   